﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace AppendixSample
{
    public class PropertySample
    {
        //メンバー変数。外部のクラスからは隠蔽
        private String field;

        //Fieldプロパティ定義
        public String Field
        {
            get //プロパティの取得
            {
                //メンバー変数の値をそのまま返す
                return field;
            }
            set //プロパティの代入
            {
                //メンバー変数に値をそのまま代入する
                field = value;
            }
        }

        //メンバー変数その2。隠蔽せずそのまま公開
        public String field2;

        public int Value
        {
            get;
            set;
        }

        public PropertySample()
        {
            Value = 0;
        }
    }

    public class PropertyUser
    {
        void TestParse()
        {
            string string1 = "64";
            int value1 = int.Parse(string1); //問題なく変換される

            string string2 = "どい";
            int value2 = int.Parse(string2); //変換できず、例外が発生する

            int value3;
            if (int.TryParse(string2, out value3))
            {
                Console.WriteLine("変換成功");
            }
            else
            {
                Console.WriteLine("変換失敗");
            }
        }

        void TestProperty()
        {
            int a = 64;
            double b = 3.14;
            //整数型のa、浮動小数点型のbをToStringメソッドで文字列型に変換して連結
            string c = a.ToString() + " , " + b.ToString();
            //表示結果："64 , 3.14"
            Console.WriteLine(c);



            var propertySample = new PropertySample();
            propertySample.Field = "プロパティに代入";
            propertySample.field2 = "メンバー変数に代入";

            propertySample.Value++;

            Console.WriteLine(propertySample.Field);
            Console.WriteLine(propertySample.field2);
        }
    }

}