﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Chapter03Sample.WebServerControl
{
    public partial class ListControl : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            //メッセージ表示用ラベルに選択内容を出力していく
            Label1.Text = "<ul>";

            string selectedItemText = "";
            //複数選択のListBoxコントロールの選択項目の取得
            //ItemsプロパティからListItemを1つずつ取り出し、Selectedプロパティを確認
            foreach (ListItem item in ListBox1.Items)
            {
                //選択されていればTextプロパティを取得
                if (item.Selected)
                {
                    selectedItemText += item.Text + " ";
                }
            }
            //ListBoxコントロールの選択内容
            Label1.Text += string.Format("<li>ListBoxコントロールでは{0}が選択されています</li>"
                , selectedItemText);


            //DropDownListコントロールでは、
            //SelectedItemで選択されたListItemを
            //SelectedValueで選択されたListItemのValueプロパティを取得できる
            Label1.Text +=
                string.Format("<li>DropDownListコントロールでは、テキストが{0}、値が{1}のListItemが選択されています</li>",
                DropDownList1.SelectedItem.Text, DropDownList1.SelectedValue);

            string selectedCheckBoxText = "";

            //CheckBoxListコントロールは複数選択のListBoxコントロールと同様
            //ItemsプロパティからListItemを1つずつ取り出し、Selectedプロパティを確認
            foreach (ListItem item in CheckBoxList1.Items)
            {
                //選択されていればTextプロパティを取得
                if (item.Selected)
                {
                    selectedCheckBoxText += item.Text + " ";
                }
            }
            //CheckBoxListコントロールの選択内容
            Label1.Text += string.Format("<li>CheckBoxListコントロールでは{0}が選択されています</li>"
                , selectedCheckBoxText);


            //未選択の場合はSelectedItemプロパティがnullとなる
            if (RadioButtonList1.SelectedItem != null)
            {
                //RadioButtonListコントロールはDropDownListコントロールと同様
                //SelectedItemで選択されたListItemを
                //SelectedValueで選択されたListItemのValueプロパティを取得できる
                Label1.Text +=
                    string.Format("<li>RadioButtonListコントロールでは、テキストが{0}、値が{1}のListItemが選択されています</li>",
                    RadioButtonList1.SelectedItem.Text, RadioButtonList1.SelectedValue);
                Label1.Text += "</ul>";
            }
        }
    }
}