﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="EFGridView.aspx.cs" Inherits="Chapter06Sample.EFGridView" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ValidationSummary ID="ValidationSummary1" runat="server" ForeColor="Red" />
        名前：<asp:TextBox ID="NameTB" runat="server"></asp:TextBox>
        <asp:Button ID="Button1" runat="server" Text="検索" />
        <br />
        <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
            DataKeyNames="EmployeeId" CellPadding="4" 
            ItemType="Chapter06Sample.Employee" 
            SelectMethod="GridView1_GetData"
            UpdateMethod="GridView1_UpdateItem"
            DeleteMethod="GridView1_DeleteItem"
            ForeColor="#333333" GridLines="None">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
                <asp:HyperLinkField DataNavigateUrlFields="EmployeeId" 
                    DataNavigateUrlFormatString="~/EFFormView.aspx?EmployeeId={0}" 
                    Text="詳細" />
                <asp:BoundField DataField="Name" HeaderText="名前" SortExpression="Name" />
                <asp:TemplateField HeaderText="課" SortExpression="DepartmentName">
                    <EditItemTemplate>
                        <asp:DropDownList ID="DropDownList1" runat="server" 
                            DataTextField="Name" 
                            ItemType="Chapter06Sample.Department" SelectMethod="SelectDepartments"
                            DataValueField="DepartmentId" SelectedValue='<%# BindItem.DepartmentId %>'>
                        </asp:DropDownList>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%#  BindItem.Department.Name %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="誕生日" SortExpression="Birthday">
                    <EditItemTemplate>
                        <asp:Calendar ID="Calendar1" runat="server" 
                            SelectedDate='<%# BindItem.Birthday %>' VisibleDate='<%# BindItem.Birthday %>'>
                        </asp:Calendar>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" 
                            Text='<%# Item.Birthday.ToString("yyyy/MM/dd") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="今期売上高" SortExpression="Sales">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# BindItem.Sales %>'></asp:TextBox>
                        <asp:CompareValidator ID="CompareValidator1" runat="server" 
                            ControlToValidate="TextBox1" ErrorMessage="今期売上高には正の値を入力してください" 
                            Operator="GreaterThan" ValueToCompare="0" ForeColor="Red">*</asp:CompareValidator>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" 
                            ControlToValidate="TextBox1" ErrorMessage="今期売上高を入力してください" ForeColor="Red">*</asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label3" runat="server" Text='<%# Item.Sales.ToString("C") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:BoundField DataField="TelNo" HeaderText="電話番号" SortExpression="TelNo" />
                <asp:TemplateField HeaderText="性別" SortExpression="Sex">
                    <EditItemTemplate>
                        <asp:RadioButtonList ID="RadioButton1" runat="server" 
                            SelectedValue='<%# BindItem.Sex %>'>
                        <asp:ListItem Text="男性" Value="True" />
                        <asp:ListItem Text="女性" Value="False" />
                        </asp:RadioButtonList>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" 
                            ErrorMessage="性別を選択してください" ControlToValidate="RadioButton1"></asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="SexLabel" runat="server" Text='<%# Item.Sex ?"男性":"女性" %>'> </asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:CommandField ShowDeleteButton="True" ShowEditButton="True" 
                    ButtonType="Button" />
            </Columns>
            <EditRowStyle BackColor="#7C6F57" />
            <FooterStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="#666666" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#E3EAEB" />
            <SelectedRowStyle BackColor="#C5BBAF" Font-Bold="True" ForeColor="#333333" />
            <SortedAscendingCellStyle BackColor="#F8FAFA" />
            <SortedAscendingHeaderStyle BackColor="#246B61" />
            <SortedDescendingCellStyle BackColor="#D4DFE1" />
            <SortedDescendingHeaderStyle BackColor="#15524A" />
        </asp:GridView>
    
    </div>
    </form>
</body>
</html>
