﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.ModelBinding;

namespace Chapter06Sample
{
    public partial class EFGridView : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        //Employeeのコレクションを返す
        //IQueryableはLINQで一覧を返す時に使用するデータ型
        public IQueryable<Employee> GridView1_GetData([Control("NameTB")] string name)
        {
            //コンテキストクラスのインスタンスを生成
            var context = new MyModel();

            //SQL取得用コード
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            context.Database.Log = x => sb.AppendLine(x);


            IQueryable<Employee> result;
            if (string.IsNullOrEmpty(name))
            {
                //従業員一覧を返す
                return context.Employees;
            }
            else
            {
                //部分一致検索をして返す
                result = context.Employees.Where(x => x.Name.Contains(name)).ToList().AsQueryable();
                var sql = sb.ToString();
                return result;
            }

        }
        
        public IQueryable<Department> SelectDepartments()
        {
            var context = new MyModel();
            return context.Departments;
        }

        // ID パラメーター名は、コントロールに設定されている DataKeyNames 値に一致する必要があります
        public void GridView1_UpdateItem(int EmployeeId)
        {
            var context = new MyModel();
            //context.Configuration.AutoDetectChangesEnabled = false;

            //SQL取得用コード
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            context.Database.Log = x => sb.AppendLine(x);

            var item = context.Employees.Where(x => x.EmployeeId == EmployeeId).FirstOrDefault();
            // ここに項目を読み込みます。例: item = MyDataLayer.Find(id);
            if (item == null)
            {
                // 項目が見つかりませんでした
                ModelState.AddModelError("", String.Format("ID {0} の項目が見つかりませんでした", EmployeeId));
                return;
            }
            TryUpdateModel(item);
            if (ModelState.IsValid)
            {
                //context.Entry(item).State = System.Data.Entity.EntityState.Modified;
                context.SaveChanges();
            }
            var sql = sb.ToString();
        }

        // ID パラメーター名は、コントロールに設定されている DataKeyNames 値に一致する必要があります
        public void GridView1_DeleteItem(int EmployeeId)
        {
            var context = new MyModel();

            //SQL取得用コード
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            context.Database.Log = x => sb.AppendLine(x);

            var item = context.Employees.Where(x => x.EmployeeId == EmployeeId).FirstOrDefault();
            context.Employees.Remove(item);
            context.SaveChanges();
            var sql = sb.ToString();
        }

    }
}