﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Chapter06Sample
{
    public partial class EFListView : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public IQueryable<Department> SelectDepartments()
        {
            var context = new MyModel();
            return context.Departments;
        }

        public IQueryable<Chapter06Sample.Employee> ListView1_GetData()
        {
            var context = new MyModel();
            return context.Employees;
        }

        // ID パラメーター名は、コントロールに設定されている DataKeyNames 値に一致する必要があります
        public void ListView1_UpdateItem(int EmployeeId)
        {
            var context = new MyModel();
            var item = context.Employees.Where(x => x.EmployeeId == EmployeeId).FirstOrDefault();
            // ここに項目を読み込みます。例: item = MyDataLayer.Find(id);
            if (item == null)
            {
                // 項目が見つかりませんでした
                ModelState.AddModelError("", String.Format("ID {0} の項目が見つかりませんでした", EmployeeId));
                return;
            }
            TryUpdateModel(item);
            if (ModelState.IsValid)
            {
                context.Entry(item);
                context.SaveChanges();
            }
        }

        // ID パラメーター名は、コントロールに設定されている DataKeyNames 値に一致する必要があります
        public void ListView1_DeleteItem(int EmployeeId)
        {
            var context = new MyModel();
            var item = context.Employees.Where(x => x.EmployeeId == EmployeeId).FirstOrDefault();
            context.Employees.Remove(item);
            context.SaveChanges();
        }

        public void ListView1_InsertItem()
        {
            var item = new Chapter06Sample.Employee();
            TryUpdateModel(item);
            if (ModelState.IsValid)
            {
                var context = new MyModel();

                //SQL取得用コード
                System.Text.StringBuilder sb = new System.Text.StringBuilder();
                context.Database.Log = x => sb.AppendLine(x);

                context.Employees.Add(item);
                context.SaveChanges();

                var sql = sb.ToString();

            }
        }

    }
}